%global meadalpha %{nil}
%global meadrel %{nil}
%bcond_without mead

%global base_name wildfly-openssl

%{?scl:%scl_package %{base_name}-linux}
%{!?scl:%global pkg_name %{name}}

%global version_major 1
%global version_minor 0
%global version_micro 7

%global commitid %(cut %{_sourcedir}/source-repos -d ' ' -f 2)
%global serial 24

# XXX: this should be defined and must have all components defined or it breaks
%global version %{version_major}.%{version_minor}.%{version_micro}

# XXX: should this have leading dots?
%global version_release Final-redhat-00001

%bcond_with repolib

%if 0%{?rhel} == 6
%ifarch i386 i686
%bcond_without repolib
%endif
%endif

%if 0%{?rhel} == 7
%ifarch x86_64
%bcond_without repolib
%endif
%endif

%ifarch x86_64
%global platform %{_os}-%{_build_arch}
%else
%global platform %{_os}-i386
%endif

%global eap7_homedir %{_datadir}/wildfly

# XXX: this should be defined
%define version_reltag %(eval "echo %{version_release} | %{__sed} 's/-/_/g;'")
%define reltag %{version_reltag}.1
%global namedversion %{version}.%{version_release}

Name:           %{?scl_prefix}%{base_name}-linux
Version:        %{version}
Release:        %{serial}.%{reltag}%{?dist}
Epoch:          0
Summary:        wildfly-openssl-linux
Group:          Development/Java
License:        ASL 2.0
URL:            https://github.com/wildfly/wildfly-openssl
Source0:        %{base_name}-%{commitid}.tar.gz
Source1:        source-repos
Source2:        MANIFEST-linux-i386.MF
Source3:        MANIFEST-linux-x86_64.MF
BuildRequires:  findutils
BuildRequires:  gcc
BuildRequires:  java-devel
BuildRequires:  make
BuildRequires:  unzip
BuildRequires:  openssl-devel
BuildRequires:  %{__perl}
BuildRoot:      %{_tmppath}/%{name}-%{namedversion}-%{release}-root

%description
%{summary}.

%if 0
%package -n %{?scl_prefix}wildfly-openssl-%{platform}
Summary:        wildfly-openssl-%{platform}
Group:          Development/Java

%description -n %{?scl_prefix}wildfly-openssl-%{platform}
%{summary}.
%endif

%if %with repolib
%package repolib
Summary:        Artifacts to be uploaded to a repository library
Group:          Development/Java

%description repolib
Artifacts to be uploaded to a repository library.

This package is not meant to be installed but its contents can be extracted through rpm2cpio.
%endif

%prep
%setup -q -n %{base_name}-%{commitid}

%ifnos linux
exit 1
%endif

%ifnarch i386 i686 x86_64
exit 1
%endif

%{__mkdir_p} %{platform}/target

pushd %{platform}/target
%{__cp} -p %{_sourcedir}/MANIFEST-%{platform}.MF MANIFEST.MF
%{__perl} -pi -e 's|Implementation-Version:.*|Implementation-Version: %{namedversion}|g;' MANIFEST.MF
%{__perl} -pi -e 's|Specification-Version:.*|Specification-Version: %{namedversion}|g;' MANIFEST.MF
popd

%build
pushd %{platform}
%{__make} %{?_smp_mflags} CC="%{__cc}" CFLAGS="%{optflags}" LDFLAGS="%{?__global_ldflags}" JAVA_HOME="%{java_home}"
pushd target
%{jar} cfm wildfly-openssl-%{platform}-%{namedversion}.jar MANIFEST.MF -C classes .
%{jar} i wildfly-openssl-%{platform}-%{namedversion}.jar
popd
popd

%install
%{__rm} -rf %{buildroot}

%if 0
# jars
%{__mkdir_p} %{buildroot}%{_javadir}
%{__cp} -p %{platform}/target/wildfly-openssl-%{platform}-%{namedversion}.jar %{buildroot}%{_javadir}/wildfly-openssl-%{platform}-%{namedversion}.jar
(cd %{buildroot}%{_javadir} && for jar in *-%{namedversion}*; do %{__ln_s} ${jar} `/bin/echo ${jar} | %{__sed} -e "s|-%{namedversion}||g"`; done)
%else
%{__mkdir_p} %{buildroot}%{eap7_homedir}/modules/system/layers/base/org/wildfly/openssl/main/lib
%{__unzip} -d %{buildroot}%{eap7_homedir}/modules/system/layers/base/org/wildfly/openssl/main/lib -qqo %{platform}/target/wildfly-openssl-%{platform}-%{namedversion}.jar %{platform}/libwfssl.so
find %{buildroot}%{eap7_homedir} -type d | xargs %{__chmod} 775
find %{buildroot}%{eap7_homedir} -type f -name "*.so" | xargs %{__chmod} 775
%endif

# repolib
%if %with repolib
%{__mkdir_p} %{buildroot}%_root_datadir/java/repository.jboss.com/maven2-brew/org/wildfly/openssl/wildfly-openssl-%{platform}/%{namedversion}
%{__cp} -p %{platform}/pom.xml %{buildroot}%_root_datadir/java/repository.jboss.com/maven2-brew/org/wildfly/openssl/wildfly-openssl-%{platform}/%{namedversion}/wildfly-openssl-%{platform}-%{namedversion}.pom
%{__cp} -p %{platform}/target/wildfly-openssl-%{platform}-%{namedversion}.jar %{buildroot}%_root_datadir/java/repository.jboss.com/maven2-brew/org/wildfly/openssl/wildfly-openssl-%{platform}/%{namedversion}/wildfly-openssl-%{platform}-%{namedversion}.jar
%endif

%clean
%{__rm} -rf %{buildroot}

%if 0
%files -n %{?scl_prefix}wildfly-openssl-%{platform}
%defattr(0644,root,root,0755)
%doc README.md RELEASING.md
%{_javadir}/wildfly-openssl-%{platform}-%{namedversion}.jar
%{_javadir}/wildfly-openssl-%{platform}.jar
%else
%files -n %{?scl_prefix}wildfly-openssl-linux
%defattr(0644,root,root,0755)
%doc README.md RELEASING.md
%defattr(-,root,root,0775)
%{eap7_homedir}/modules/system/layers/base/org/wildfly/openssl/main/lib/linux-*
%endif

%if %with repolib
%files repolib
%defattr(0644,root,root,0755)
%dir /%_root_datadir/java
/%_root_datadir/java/repository.jboss.com
%endif

%changelog
* Wed Jun 19 2019 Permaine Cheung <pcheung@redhat.com> - 1.0.7-24
- Fix maven-brew dir

* Tue Jun 18 2019 Roberto Oliveira <rguimara@redhat.com> - 1.0.7-23
- upgrade to 1.0.7.Final-redhat-00001

* Tue Jan 22 2019 Permaine Cheung <pcheung@redhat.com> - 1.0.6-21
- Rebuild for 7.2.0

* Fri Nov 30 2018 Yong Yang <yyang@redhat.com> - 1.0.6-20
- BR perl to fix building on el8

* Wed Jun 13 2018 Permaine Cheung <pcheung@redhat.com> - 1.0.6-19
- Rebuild for 7.2.0

* Wed May 16 2018 Martin Minar <mminar@redhat.com> - 1.0.6-18
- update to 1.0.6.Final-redhat-1

* Wed May 16 2018 Martin Minar <mminar@redhat.com> - 1.0.6-17
- update to 1.0.6.Final-redhat-1

* Wed May 16 2018 Martin Minar <mminar@redhat.com> - 1.0.6-16
- update to version 1.0.6.Final-redhat-1

* Fri May 04 2018 Martin Minar <mminar@redhat.com> - 1.0.6-15
- 1.0.6.Final-redhat-1

* Fri May 04 2018 Martin Minar <mminar@redhat.com> - 1.0.6-14
- 1.0.6.Final-redhat-1

* Mon Aug 21 2017 Martin Minar <mminar@redhat.com> - 1.0.2-13
- update to 1.0.2.Final-redhat-1

* Tue Aug 15 2017 Martin Minar <mminar@redhat.com> - 1.0.0-12
- 1.0.0.Final-redhat-1

* Fri Jun 23 2017 Martin Minar <mminar@redhat.com> - 1.0.0-12
- update to version 1.0.0.CR5-redhat-1

* Wed May 31 2017 Martin Minar <mminar@redhat.com> - 1.0.0-11
- update 1.0.0.CR3-redhat-2

* Wed May 31 2017 Martin Minar <mminar@redhat.com> - 1.0.0-10
- update to version 1.0.0.CR3-redhat-2

* Wed May 31 2017 Martin Minar <mminar@redhat.com> - 1.0.0-9
- update to version 1.0.0.CR3-redhat-2

* Mon May 22 2017 Martin Minar <mminar@redhat.com> - 1.0.0-8
- update to version 1.0.0.CR3

* Wed Apr 05 2017 David Walluck <dwalluck@redhat.com> - 0:1.0.0-6.CR1_redhat_1.1
- release
